
Ruby - Bug #14689

bootsnap gets object index out of range: 266287972352 (IndexError) since r63113

04/16/2018 06:52 AM - yahonda (Yasuo Honda)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v: ruby 2.6.0dev (2018-04-16 trunk 63163)

[x86_64-linux]

Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:

REQUIRED

Description

Steps to reproduce

$ rbenv install 2.6.0-dev

$ rbenv global 2.6.0-dev

$ git clone https://github.com/Shopify/bootsnap

$ cd bootsnap

$ bundle

$ rake

$ bundle exec bin/testunit

 

Expected result as of r63112

$ ruby -v

ruby 2.6.0dev (2018-04-07 trunk 63112) [x86_64-linux]

$ bundle exec bin/testunit

... snip ....

# Running:

..................................................................................................

...................

Finished in 0.098554s, 1187.1708 runs/s, 2059.7920 assertions/s.

117 runs, 203 assertions, 0 failures, 0 errors, 0 skips

$

 

Actual result since r63113

$ ruby -v

ruby 2.6.0dev (2018-04-07 trunk 63113) [x86_64-linux]

$ bundle exec bin/testunit

... snip ...

Traceback (most recent call last):

 9: from /home/yahonda/.rbenv/versions/2.6.0-dev_yahonda/lib/ruby/gems/2.6.0/gems/minitest-5.11.3/

lib/minitest.rb:63:in `block in autorun'

 8: from /home/yahonda/.rbenv/versions/2.6.0-dev_yahonda/lib/ruby/gems/2.6.0/gems/minitest-5.11.3/

lib/minitest.rb:121:in `run'

 7: from /home/yahonda/.rbenv/versions/2.6.0-dev_yahonda/lib/ruby/gems/2.6.0/gems/minitest-5.11.3/

lib/minitest.rb:92:in `load_plugins'

 6: from /home/yahonda/.rbenv/versions/2.6.0-dev_yahonda/lib/ruby/gems/2.6.0/gems/minitest-5.11.3/

lib/minitest.rb:92:in `each'

 5: from /home/yahonda/.rbenv/versions/2.6.0-dev_yahonda/lib/ruby/gems/2.6.0/gems/minitest-5.11.3/

lib/minitest.rb:98:in `block in load_plugins'

 4: from /home/yahonda/.rbenv/versions/2.6.0-dev_yahonda/lib/ruby/gems/2.6.0/gems/minitest-5.11.3/

lib/minitest.rb:98:in `require'

 3: from /home/yahonda/git/bootsnap/lib/bootsnap/compile_cache/iseq.rb:37:in `load_iseq'

 2: from /home/yahonda/git/bootsnap/lib/bootsnap/compile_cache/iseq.rb:37:in `fetch'

 1: from /home/yahonda/git/bootsnap/lib/bootsnap/compile_cache/iseq.rb:18:in `storage_to_output'

/home/yahonda/git/bootsnap/lib/bootsnap/compile_cache/iseq.rb:18:in `load_from_binary': object ind
ex out of range: 266287972352 (IndexError)

$

 

iseq.rb:18 executes RubyVM::InstructionSequence.load_from_binary

https://github.com/Shopify/bootsnap/blob/30ac9d332d758d8641e5775541e7b0b2f13bff58/lib/bootsnap/compile_cache/iseq.rb#L18

        RubyVM::InstructionSequence.load_from_binary(binary)

Related issues:

Has duplicate Ruby - Bug #16033: test_callinfo_unreachable_path Bus Error on ... Closed

Associated revisions

Revision 58a2084483ce8baaf90d7b1cb00e3fa9570fbc79 - 04/16/2018 12:46 PM - nobu (Nobuyoshi Nakada)

compile.c: align range

compile.c (ibf_dump_object_struct): align range elements.

[ruby-core:86548] [Bug #14689]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63167 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 58a20844 - 04/16/2018 12:46 PM - nobu (Nobuyoshi Nakada)

compile.c: align range

compile.c (ibf_dump_object_struct): align range elements.

[ruby-core:86548] [Bug #14689]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63167 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 04/16/2018 12:46 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset trunk|r63167.

compile.c: align range

compile.c (ibf_dump_object_struct): align range elements.

[ruby-core:86548] [Bug #14689]

#2 - 04/18/2018 10:59 AM - yahonda (Yasuo Honda)

I have also validated the fix using "ruby 2.6.0dev (2018-04-18 trunk 63186) [x86_64-linux]"

Thank you.

#3 - 08/02/2019 12:00 AM - nobu (Nobuyoshi Nakada)

- Has duplicate Bug #16033: test_callinfo_unreachable_path Bus Error on Solaris sparc added

#4 - 08/09/2019 04:38 PM - glaubitz (John Paul Adrian Glaubitz)

Would it be possible to backport this patch for ruby2.5? Debian has unfortunately not yet updated to 2.6 and the bug affects Debian's sparc64 port.

The patch as-is doesn't apply to the 2.5 tree.

#5 - 08/16/2019 09:21 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5: UNKNOWN to 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5: REQUIRED
